#pragma once

#include <saas/indexerproxy/adapters/interface_adapter.h>

//#define __TEST_ONLY
namespace NIndexerProxy {

    class TAdapter: public IAdapter {
    protected:
        virtual void ParseConfig(const TAdapterMinimalConfig& config);

    protected:
        virtual bool ParseMessage(ISenderTask& context) const = 0;
        virtual bool PreprocessMessage(ISenderTask& context) const;

    public:
        virtual void ProcessMessage(ISenderTask& context) const override;
        TAdapter(const TAdapterInitializationList& arguments);
    };
};
